OpenVDB 12.1.0

Loading...
Searching...
No Matches
Statement Struct Referenceabstract

Abstract (pure-virtual) AST nodes. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for Statement:

## Public Types
using | UniquePtr = std::unique_ptr<Statement>
enum | NodeType { TreeNode , StatementListNode , BlockNode , ConditionalStatementNode , CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode , CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode , CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode , DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode , ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node , ValueFloatNode , ValueDoubleNode , ValueStrNode }
| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr<Node>

## Public Member Functions
| ~Statement () override=default
virtual Statement * | copy () const override=0
| The deep copy method for a Node.
const Node * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
Name/Type
virtual NodeType | nodetype () const =0
| Virtual method for accessing node type information.
virtual const char * | nodename () const =0
| Virtual method for accessing node name information.
virtual const char * | subname () const =0
| Virtual method for accessing node name information.
template<typename NodeT>
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()
Child Queries
virtual size_t | children () const =0
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
virtual const Node * | child (const size_t index) const =0
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
virtual bool | replacechild (const size_t index, Node *node)
| Virtual method that attempted to replace a child at a given index with a provided node type.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Detailed Description

Abstract (pure-virtual) AST nodes.

Statements are anything that can make up a line, i.e. everything in between semicolons. Likewise to their base ast::Node class, currently every concrete AST node is either directly or indirectly a derived statement type. They hold no class data.

## Member Typedef Documentation

## ◆ Ptr

using Ptr = std::shared_ptr<Node>
| inherited

## ◆ UniquePtr

using UniquePtr = std::unique_ptr<Statement>

## Member Enumeration Documentation

## ◆ NodeType

enum NodeType
| inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## ◆ ~Statement()

~Statement | ( |  | ) |
| override default

## Member Function Documentation

## ◆ basetype()

const Node * basetype | ( |  | ) | const
| inline override virtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Returns
  Returns the current node as its base class type.

Reimplemented from Node.

Reimplemented in StatementList, TernaryOperator, UnaryOperator, Value< T >, Value< std::string >, ValueBase, and Variable.

## ◆ child()

virtual const Node * child | ( | const size_t | index | ) | const
| pure virtual inherited

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Note
  This may still return a nullptr even if the given index is valid if the child node has not been created.

Parameters

  index | The child index to query

Returns
  A Pointer to the child node, or a nullptr if none exists.

Implemented in ArrayPack, ArrayUnpack, AssignExpression, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, FunctionCall, Keyword, Loop, StatementList, TernaryOperator, Tree, UnaryOperator, ValueBase, and Variable.

## ◆ childidx()

int64_t childidx | ( |  | ) | const
| inline inherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)

Returns
  The child index of this node

## ◆ children()

virtual size_t children | ( |  | ) | const
| pure virtual inherited

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Returns
  The number of children this node owns.

Implemented in ArrayPack, ArrayUnpack, AssignExpression, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, FunctionCall, Keyword, Loop, StatementList, TernaryOperator, Tree, UnaryOperator, ValueBase, and Variable.

## ◆ copy()

virtual Statement * copy | ( |  | ) | const
| override pure virtual

The deep copy method for a Node.

Returns
  A deep copy of the current node and all its children

Implements Node.

Implemented in ArrayPack, ArrayUnpack, AssignExpression, Attribute, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, Expression, ExternalVariable, FunctionCall, Keyword, Local, Loop, StatementList, TernaryOperator, UnaryOperator, Value< T >, Value< std::string >, ValueBase, and Variable.

## ◆ isType()

template<typename NodeT>

bool isType | ( |  | ) | const
| inline inherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## ◆ nodename()

virtual const char * nodename | ( |  | ) | const
| pure virtual inherited

Virtual method for accessing node name information.

Returns
  Returns the node class name

Implemented in ArrayPack, ArrayUnpack, AssignExpression, Attribute, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, ExternalVariable, FunctionCall, Keyword, Local, Loop, StatementList, TernaryOperator, Tree, UnaryOperator, Value< T >, and Value< std::string >.

## ◆ nodetype()

virtual NodeType nodetype | ( |  | ) | const
| pure virtual inherited

Virtual method for accessing node type information.

Note
  This method should be used when querying a concrete nodes type.

Returns
  Returns the enumerated node type from the NodeType list

Implemented in ArrayPack, ArrayUnpack, AssignExpression, Attribute, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, ExternalVariable, FunctionCall, Keyword, Local, Loop, StatementList, TernaryOperator, Tree, UnaryOperator, Value< T >, and Value< std::string >.

## ◆ parent()

const Node * parent | ( |  | ) | const
| inline inherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## ◆ replace()

bool replace | ( | Node * | node | ) |
| inline inherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## ◆ replacechild()

bool replacechild | ( | const size_t | index,
|  | Node * | node )
| inline virtual inherited

Virtual method that attempted to replace a child at a given index with a provided node type.

Note
  See Node::replace for a more detailed description

Parameters

  index | The child index where a replacement should be attempted
  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, false otherwise

Reimplemented in ArrayPack, ArrayUnpack, AssignExpression, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, FunctionCall, Loop, StatementList, TernaryOperator, and UnaryOperator.

## ◆ setParent()

void setParent | ( | Node * | parent | ) |
| inline inherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## ◆ subname()

virtual const char * subname | ( |  | ) | const
| pure virtual inherited

Virtual method for accessing node name information.

Returns
  Returns the short node class name

Implemented in ArrayPack, ArrayUnpack, AssignExpression, Attribute, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, ExternalVariable, FunctionCall, Keyword, Local, Loop, StatementList, TernaryOperator, Tree, UnaryOperator, Value< T >, and Value< std::string >.